#define __KERNEL__
#define MODULE

#include <linux/config.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/errno.h>

/* Falesna funkce realizujici systemove volani mkdir() */
asmlinkage long MY_sys_mkdir(const char * pathname, int mode)
{
  return -EPERM;	/* jenom vrati tuto chybu */
}

long (*old_sys_mkdir)(const char *, int);

/* index volani mkdir() v tabulce volani jadra (viz arch/i386/kernel/entry.S) */
#define SYSCALL_INDEX_mkdir	39
extern void *sys_call_table[]; /* tabulka volani jadra je definovana jinde */

int __init MUJ_MKDIR_MODUL_init(void)
{
  printk(KERN_ALERT "MUJ_MKDIR_MODUL: Jsem v jadre!\n");
  printk(KERN_ALERT "MUJ_MKDIR_MODUL: Blokuji vytvoreni adresare!\n");
  old_sys_mkdir=sys_call_table[SYSCALL_INDEX_mkdir];
  sys_call_table[SYSCALL_INDEX_mkdir]=MY_sys_mkdir;
  return 0;
}

void MUJ_MKDIR_MODUL_exit(void)
{
  sys_call_table[SYSCALL_INDEX_mkdir]=old_sys_mkdir;
  printk(KERN_ALERT "MUJ_MKDIR_MODUL: Koncim!\n");
}

module_init(MUJ_MKDIR_MODUL_init);
module_exit(MUJ_MKDIR_MODUL_exit);

MODULE_LICENSE("GPL");
